<!doctype html>
<html lang="de-DE">

{{> head }}

<body>
  <div>
    {{> breadcrumbs }}
    <div id="ovk-content">
      <h1>Multidimensionale Modellierung</h1>
      <p>
        Der Ausdruck <b>Multidimensionale Modellierung</b> bezieht sich auf einen Ansatz der Datenmodellierung, bei dem Daten in einer mehrdimensionalen Struktur organisiert werden. Im Gegensatz zu traditionellen, tabellenbasierten relationalen Datenbanken ermöglicht die multidimensionale Modellierung eine effizientere Darstellung und Analyse komplexer Beziehungen zwischen verschiedenen Datenelementen. Häufig tritt dieser Ansatz im Kontext von <b>Online-Analytical-Processing-Systemen (OLAP)</b> in Erscheinung.
      </p>

      <details>
        <summary><span>OLAP vs. OLTP</span></summary>
        <p>
          OLAP (Online <b>Analytical</b> Processing) und OLTP (Online <b>Transaction</b> Processing) sind Begriffe für zwei unterschiedliche Datenbankverarbeitungskonzepte, welche jeweils auf verschiedene Anforderungen und Aufgaben im Bereich des Datenbankmanagements ausgerichtet sind. <br>
          Die in den vorausgehenden Abschnitten betrachteten OLTP-Systeme konzentrieren sich auf den Betrieb von Anwendungen, bei denen <b>viele Transaktionen in Echtzeit</b> verarbeitet werden müssen. OLTP-Datenbanken unterstützen dazu häufige Lese- und Schreibzugriffe auf <b>aktuelle Daten</b>.<br>
          OLAP-Systeme fokussieren sich demgegenüber auf die <b>Auswertung und Analyse</b> großer Mengen <b>historischer Daten</b>. OLAP-Datenbanken sind für komplexe Abfragen und zusammenfassende Berichte optimiert. Auf diese Weise können sie beispielsweise dazu beitragen, wichtige Geschäftsentscheidungen fundiert zu treffen.<br>
          In vielen Organisationen werden <b>OLAP- und OLTP-Systeme gemeinsam eingesetzt</b>, um den unterschiedlichen Anforderungen von Transaktionsverarbeitung und analytischer Datenauswertung gerecht zu werden. In der folgenden Darstellung werden wichtige Eigenschaften beider Konzepte gegenübergestellt:
        </p>

        <div class="nav nav-tabs" role="tab">
          <button class="nav-link active" data-bs-toggle="tab" href="#home_olap_oltp">Zielstellung</button>
          <button class="nav-link" data-bs-toggle="tab" href="#menu_olap_oltp1">Datenstruktur</button>
          <button class="nav-link" data-bs-toggle="tab" href="#menu_olap_oltp2">Abfragekomplexität</button>
          <button class="nav-link" data-bs-toggle="tab" href="#menu_olap_oltp3">Geschwindigkeit</button>
          <button class="nav-link" data-bs-toggle="tab" href="#menu_olap_oltp4">Datenmenge</button>
          <button class="nav-link" data-bs-toggle="tab" href="#menu_olap_oltp5">Anwendungen</button>
        </div>

        <div class="tab-content">
          <div class="tab-pane container active" id="home_olap_oltp">
            <table>
              <tr>
                <td><b>OLAP</b></td>
                <td>Komplexe Auswertung und Analyse großer Mengen historischer Daten</td>
              </tr>
              <tr>
                <td><b>OLTP</b></td>
                <td>Täglicher Betrieb von Anwendungen, bei denen viele Transaktionen in Echtzeit verarbeitet werden müssen</td>
              </tr>
            </table>
          </div>
          <div class="tab-pane container" id="menu_olap_oltp1">
            <table>
              <tr>
                <td><b>OLAP</b></td>
                <td>Stern- oder schneeflockenförmiges Datenbankmodell</td>
              </tr>
              <tr>
                <td><b>OLTP</b></td>
                <td>Relationales Datenbankmodell mit normalisierten Tabellen</td>
              </tr>
            </table>
          </div>
          <div class="tab-pane container" id="menu_olap_oltp2">
            <table>
              <tr>
                <td><b>OLAP</b></td>
                <td>Unterstützt komplexe Abfragen (bspw. Trendanalysen oder Data Mining), die Aggregationen, Gruppierungen und multidimensionale Analysen erfordern</td>
              </tr>
              <tr>
                <td><b>OLTP</b></td>
                <td>Verarbeitet einfache Abfragen zur Datenmanipulation, Aktualisierung, Einfügung und Löschung</td>
              </tr>
            </table>
          </div>
          <div class="tab-pane container" id="menu_olap_oltp3">
            <table>
              <tr>
                <td><b>OLAP</b></td>
                <td>Verarbeitung komplexer Abfragen im Fokus; Echtzeitverarbeitung besitzt untergeordnete Priorität</td>
              </tr>
              <tr>
                <td><b>OLTP</b></td>
                <td>Schnelle Verarbeitung von Transaktionen in Echtzeit im Vordergrund, um die Aktualität der zu verwaltenden Daten zu gewährleisten</td>
              </tr>
            </table>
          </div>
          <div class="tab-pane container" id="menu_olap_oltp4">
            <table>
              <tr>
                <td><b>OLAP</b></td>
                <td>Verarbeitung großer Mengen historischer Daten – Datenmengen im Terabyte- oder Petabyte-Bereich nicht unüblich</td>
              </tr>
              <tr>
                <td><b>OLTP</b></td>
                <td>Verarbeitung aktueller Transaktionsdaten – i.d.R. kleinere Datenmengen im Vergleich zu OLAP-Datenbanken</td>
              </tr>
            </table>
          </div>
          <div class="tab-pane container" id="menu_olap_oltp5">
            <table>
              <tr>
                <td><b>OLAP</b></td>
                <td>Business-Intelligence-Anwendungen, Data Warehousing, Managementreporting</td>
              </tr>
              <tr>
                <td><b>OLTP</b></td>
                <td>E-Commerce-Websites, Banktransaktionssysteme, Buchungssysteme</td>
              </tr>
            </table>
          </div>
        </div>
      </details>
      
      <details>
        <summary><span>OLAP-Datenwürfel</span></summary>

        <figure style="max-width: 18em; background-color: inherit;" class="ovk-float-right">
          <img src="https://upload.wikimedia.org/wikipedia/commons/c/cc/Olap-3d-cube.png" />
          <caption><center>Darstellung eines Datenwürfels<sup><a href="#source1">1</a></sup></center></caption>
        </figure>

        <p>
          Ein OLAP-Datenwürfel ist eine <b>multidimensionale Datenstruktur</b>, die dazu dient, komplexe Daten in einer leicht verständlichen Form zu organisieren und zu analysieren. Der Begriff "Würfel" bezieht sich auf die Idee, dass die Daten in mehreren Dimensionen organisiert sind, ähnlich den Seiten eines Würfels. In der Praxis können OLAP-Datenwürfel jedoch <b>mehr als drei Dimensionen</b> aufweisen. Jede Dimension stellt dabei einen relevanten Aspekt der zu organisierenden Daten dar und kann wiederum in verschiedene <b>Hierachieebenen</b> gegliedert sein. Die Zellen des Würfels repräsentieren <b>aggregierte Werte</b>, die durch das Zusammenspiel der verschiedenen Dimensionen bestimmt werden. Auf diese Weise ermöglichen OLAP-Datenwürfel, Daten aus unterschiedlichen Blickwinkeln zu betrachten, Trends zu identifizieren und tiefgehende Einblicke in komplexe Datenzusammenhänge zu gewinnen.
        </p>

        <div class="card ovk-hinweis">
          <div class="card-header"><b>Anwendungsbeispiel</b></div>
          <div class="card-body">
            <p>
              Ein Unternehmen verfügt landesweit über mehrere Standorte. Mithilfe eines  OLAP-Datenwürfels werden Verkaufsdaten in den Dimensionen <i>Zeit</i>, <i>Produkt</i> und <i>Region</i> erfasst. Analyst:innen könnten den Würfel beispielsweise bei der Erstellung eines Quartalsberichts verwenden, um den Umsatz für ein bestimmtes Produkt in einer bestimmten Region über verschiedene Zeiträume hinweg zu untersuchen.
            </p>
          </div>
        </div>
        
        <br>

        <details style="padding-bottom: 0;">
          <summary><span style="font-size: 1.3em">Operationen auf OLAP-Datenwürfeln</span></summary>
          <p>
            Um mithilfe eines OLAP-Datenwürfels komplexe Datenanalysen durchführen zu können, werden folgende Grundoperationen unterschieden, welche entweder einzeln oder in Kombination eingesetzt werden können:
          </p>

          <div class="nav nav-tabs" role="tab">
            <button class="nav-link active" data-bs-toggle="tab" href="#home_operationen">Slicing</button>
            <button class="nav-link" data-bs-toggle="tab" href="#menu_operationen_1">Dicing</button>
            <button class="nav-link" data-bs-toggle="tab" href="#menu_operationen_2">Pivoting</button>
            <button class="nav-link" data-bs-toggle="tab" href="#menu_operationen_3">Drill-Down</button>
            <button class="nav-link" data-bs-toggle="tab" href="#menu_operationen_4">Roll-Up</button>
            <button class="nav-link" data-bs-toggle="tab" href="#menu_operationen_5">Drill-Across</button>
          </div>

          <div class="tab-content">
            <div class="tab-pane container active" id="home_operationen">
              <table>
                <tr>
                  <td><b>Operation:</b></td>
                  <td>Herausnahme von <i>Scheiben</i> des Datenwürfels</td>
                </tr>
                <tr>
                  <td><b>Beispiel:</b></td>
                  <td>Anzeige der Verkaufszahlen für einen Monat des Verkaufsjahres</td>
                </tr>
              </table>
            </div>
            <div class="tab-pane container" id="menu_operationen_1">
              <table>
                <tr>
                  <td><b>Operation:</b></td>
                  <td>Herausnahme von <i>Teilwürfeln</i> durch die Vorgabe von Einschränkungen auf einer oder mehreren Dimensionen</td>
                </tr>
                <tr>
                  <td><b>Beispiel:</b></td>
                  <td>Reduktion des Gesamtwürfels auf Produkte der Kategorien <i>Accessoires</i> und <i>Bekleidung</i></td>
                </tr>
              </table>
            </div>
            <div class="tab-pane container" id="menu_operationen_2">
              <table>
                <tr>
                  <td><b>Operation:</b></td>
                  <td>Änderung der Perspektive durch den Austausch der sichtbaren Dimensionen	</td>
                </tr>
                <tr>
                  <td><b>Beispiel:</b></td>
                  <td>Ansicht der Dimensionen <i>(Monat × Region)</i> statt <i>(Monat × Produktkategorie)</i></td>
                </tr>
              </table>
            </div>
            <div class="tab-pane container" id="menu_operationen_3">
              <table>
                <tr>
                  <td><b>Operation:</b></td>
                  <td><i>Hereinzoomen</i> – aggregierte Informationen werden in detailliertere Werte aufgelöst</td>
                </tr>
                <tr>
                  <td><b>Beispiel:</b></td>
                  <td>Anzeige der Monats- statt der Jahresansicht</td>
                </tr>
              </table>
            </div>
            <div class="tab-pane container" id="menu_operationen_4">
              <table>
                <tr>
                  <td><b>Operation:</b></td>
                  <td><i>Herauszoomen</i> – Einzelwerte werden zur Betrachtung auf einer höheren Hierarchiestufe aggregiert</td>
                </tr>
                <tr>
                  <td><b>Beispiel:</b></td>
                  <td>Anzeige der Jahres- statt der Monatsansicht</td>
                </tr>
              </table>
            </div>
            <div class="tab-pane container" id="menu_operationen_5">
              <table>
                <tr>
                  <td><b>Operation:</b></td>
                  <td>Gegenüberstellung verschiedener Werte auf der gleichen Hierarchieebene</td>
                </tr>
                <tr>
                  <td><b>Beispiel:</b></td>
                  <td>Vergleich der Verkaufszahlen für zwei verschiedene Produkte im selben Monat</td>
                </tr>
              </table>
            </div>
          </div>
        </details>

        <iframe src="https://olap-wuerfel-db-vorbereitungskurs-optla-flashcar-e5fe778f5a717e.gitlab.io" style="width: 100%; height: 270px; border: 1px solid #ced4da; border-radius: 10px; margin-top: 2.5em;"></iframe>

      </details>

      <details>
        <summary><span>Sternschema und Schneeflockenschema</span></summary>
        <table>
          <tr>
            <td style="border: none">
              <img src="https://upload.wikimedia.org/wikipedia/commons/7/78/Star_Schema.png" /><br>
              <center>Darstellung des Sternschemas<sup><a href="#source2">2</sup></center>
            </td>
            <td style="border: none">
              <img src="https://upload.wikimedia.org/wikipedia/commons/1/1d/Snowflake_schema.png" /><br>
              <center>Darstellung des Schneeflockenschemas<sup><a href="#source3">3</sup></center>
            </td>
          </tr>
        </table>
        <p>
          Das Sternschema und das Schneeflockenschema beschreiben Entwurfsmodelle für relationale Datenbanken zur <b>Auswertung und Analyse großer Mengen historischer Daten</b>. Gegenüber klassischen relationalen Datenbankmodellen besteht die Zielstellung hierbei nicht vorrangig in der Normalisierung, sondern in der Optimierung auf effiziente Leseoperationen. Beide Schemata verwenden hierzu zwei verschiedene Tabellenarten: eine <b>Faktentabelle</b> und mehrere <b>Dimensionstabellen</b>.
        </p>

        <details>
          <summary><span style="font-size: 1.3em">Aufbau der Schemata</span></summary>
          <p>
            Die durch die Schemata zu verwaltenden Daten werden <b>Fakten</b> genannt und fortlaufend in der im Zentrum stehenden Faktentabelle gespeichert. Die Daten der Faktentabelle repräsentieren jene <b>Kennzahlen und Metriken, welche im Analyseprozess berücksichtigt werden sollen</b> (z.B. Wert einer Bestellung, Menge bestellter Produkte oder Lagerbestand eines Produktes). Attribute, die die Daten der Faktentabelle genauer beschreiben oder mittels <b>Kontextinformationen</b> kategorisieren, werden hingegen in den Dimensionstabellen gespeichert (z.B. Produkt- oder Kundeninformationen).
          </p>
        </details>

        <details>
          <summary><span style="font-size: 1.3em">Unterschiede zwischen Stern- und Schneeflockenschema</span></summary>
          <p>
            Das Stern- und das Schneeflockenschema unterscheiden sich wesentlich hinsichtlich der Hierarchisierung ihrer Dimensionen. Im Gegensatz zum Schneeflockenschema steht beim <b>Sternschema</b> jede Dimensionstabelle in einer direkten <b>1:N-Beziehung zur zentralen Faktentabelle</b>. Hieraus folgt, dass die Dimensionen nicht hierarchisch in mehrere Unterdimensionen aufgeteilt werden können, weshalb die <b>Dimensionstabellen häufig nicht in der 3. Normalform</b> vorliegen. Die Konsequenzen der geringeren Datenintegrität und des höheren Speicherplatzbedarfs werden hierbei in Kauf genommen, da die <b>Abfrageleistung durch die geringere Anzahl erforderlicher Joins gesteigert</b> werden kann. 
          </p>
        </details>
        <iframe src="https://sternschema-schneeflockenschema-db-vorbereitungs-f1149cb498d5a8.gitlab.io" style="width: 100%; height: 295px; border: 1px solid #ced4da; border-radius: 10px; margin-top: 2em;"></iframe>
      </details>

      <br>
      <details>
        <summary><span style="font-size: 1.3em">Bildquellen</span></summary>
        <ol>
          <li id="source1"><a href="https://upload.wikimedia.org/wikipedia/commons/c/cc/Olap-3d-cube.png?20201209223311" target="_blank">Margaret Rouse, olap.com, Guru99, CC BY-SA 4.0</a></li>
          <li id="source2"><a href="https://upload.wikimedia.org/wikipedia/commons/7/78/Star_Schema.png" target="_blank">Star Schema Dhbw dbi, CC BY-SA 3.0</a></li>
          <li id="source3"><a href="https://upload.wikimedia.org/wikipedia/commons/1/1d/Snowflake_schema.png" target="_blank">Snowflake Schema Dhbw dbi, CC BY-SA 3.0</a></li>
        </ol>  
      </details>

      {{> footer }}
    </div>
  </div>
</body>